﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7
@EndOfDesignText@
#IgnoreWarnings: 12

Sub Class_Globals
	
	Private BANano As BANano 'ignore
	
	Private nw As BANanoObject
	
	Private currentWindow As BANanoObject
	
End Sub

Public Sub Initialize
	
	nw.Initialize("nw")

	currentWindow = nw.GetField("Window").RunMethod("get", Null)
	
End Sub

'
'Get the current window
'
'<link>NodeJS Documentation|http://docs.nwjs.io/en/latest/References/Window/#windowgetwindow_object</link>
Sub Get() As BANanoObject
	Return nw.GetField("Window").RunMethod("get", Null).Result
End Sub

'
'Set/Get the X-Coordinate
'
'<link>NodeJS Documentation|http://docs.nwjs.io/en/latest/References/Window/#winx</link>
Sub setX(X As Int)
	currentWindow.setField("x", X)
End Sub
Sub getX() As Int
	Return currentWindow.GetField("x").Result
End Sub

'
'Set/Get the Y-Coordinate
'
'<link>NodeJS Documentation|http://docs.nwjs.io/en/latest/References/Window/#winy</link>
Sub setY(Y As Int)
	currentWindow.setField("y", Y)
End Sub
Sub getY() As Int
	Return currentWindow.GetField("y").Result
End Sub

'
'Set/Get the width
'
'<link>NodeJS Documentation|http://docs.nwjs.io/en/latest/References/Window/#winwidth</link>
Sub setWidth(Width As Int)
	currentWindow.setField("width", Width)
End Sub
Sub getWidth() As Int
	Return currentWindow.GetField("width").Result
End Sub

'
'Set/Get the height
'
'<link>NodeJS Documentation|http://docs.nwjs.io/en/latest/References/Window/#winheight</link>
Sub setHeight(Height As Int)
	currentWindow.setField("height", Height)
End Sub
Sub getHeight() As Int
	Return currentWindow.GetField("height").Result
End Sub

'
'Set/Get the title
'
'<link>NodeJS Documentation|http://docs.nwjs.io/en/latest/References/Window/#wintitle</link>
Sub setTitle(Title As String)
	
	' currentWindow.setField("title", Title) ' doesn't work

	' fix: use document.title:
	Dim Document As BANanoObject
	Document.Initialize("document")
	Document.SetField("title", Title)

End Sub
Sub getTitle() As String
	Return currentWindow.GetField("title").Result
End Sub

'
'Move the window to the given coordinates
'
'<link>NodeJS Documentation|http://docs.nwjs.io/en/latest/References/Window/#winmovetox-y</link>
Sub MoveTo(X As Int, Y As Int)
	currentWindow.RunMethod("moveTo", Array(X, Y))
End Sub

'
'Move the window by the given coordinates
'
'<link>NodeJS Documentation|http://docs.nwjs.io/en/latest/References/Window/#winmovebyx-y</link>
Sub MoveBy(X As Int, Y As Int)
	currentWindow.RunMethod("moveBy", Array(X, Y))
End Sub

'
'Resize the window to the given Width/Height
'
'<link>NodeJS Documentation|http://docs.nwjs.io/en/latest/References/Window/#winresizetowidth-height</link>
Sub ResizeTo(Width As Int, Height As Int)
	currentWindow.RunMethod("resizeTo", Array(Width, Height))
End Sub

'
'Resize the window by the given Width/Height
'
'<link>NodeJS Documentation|http://docs.nwjs.io/en/latest/References/Window/#winresizebywidth-height</link>
Sub ResizeBy(Width As Int, Height As Int)
	currentWindow.RunMethod("resizeBy", Array(Width, Height))
End Sub

'
'Focus the window
'
'<link>NodeJS Documentation|http://docs.nwjs.io/en/latest/References/Window/#winfocus</link>
Sub Focus()
	currentWindow.RunMethod("focus", Null)
End Sub

'
'Blur the window
'
'<link>NodeJS Documentation|http://docs.nwjs.io/en/latest/References/Window/#winblur</link>
Sub Blur()
	currentWindow.RunMethod("blur", Null)
End Sub

'
'Show the window
'
'<link>NodeJS Documentation|http://docs.nwjs.io/en/latest/References/Window/#winshowis_show</link>
Sub Show()
	currentWindow.RunMethod("show", Null)
End Sub

'
'Hide the window
'
'<link>NodeJS Documentation|http://docs.nwjs.io/en/latest/References/Window/#winhide</link>
Sub Hide()
	currentWindow.RunMethod("hide", Null)
End Sub

'
'Close the window
'
'<link>NodeJS Documentation|http://docs.nwjs.io/en/latest/References/Window/#wincloseforce</link>
Sub Close(Force As Boolean)
	currentWindow.RunMethod("close", Force)
End Sub

'
'Reload the window
'
'<link>NodeJS Documentation|http://docs.nwjs.io/en/latest/References/Window/#winreload</link>
Sub Reload()
	currentWindow.RunMethod("reload", Null)
End Sub

'
'Reload the window ignoring the cache
'
'<link>NodeJS Documentation|http://docs.nwjs.io/en/latest/References/Window/#winreloadignoringcache</link>
Sub ReloadIgnoringCache()
	currentWindow.RunMethod("reloadIgnoringCache", Null)
End Sub

'
'Maximize the window
'
'<link>NodeJS Documentation|http://docs.nwjs.io/en/latest/References/Window/#winmaximize</link>
Sub Maximize()
	currentWindow.RunMethod("maximize", Null)
End Sub

'
'Unmaximize the window
'
'<link>NodeJS Documentation|http://docs.nwjs.io/en/latest/References/Window/#winunmaximize</link>
Sub Unmaximize()
	currentWindow.RunMethod("unmaximize", Null)
End Sub

'
'Minimize the window
'
'<link>NodeJS Documentation|http://docs.nwjs.io/en/latest/References/Window/#winminimize</link>
Sub Minimize()
	currentWindow.RunMethod("minimize", Null)
End Sub

'
'Restore the window
'
'<link>NodeJS Documentation|http://docs.nwjs.io/en/latest/References/Window/#winrestore</link>
Sub Restore()
	currentWindow.RunMethod("restore", Null)
End Sub

'
'Enter fullscreen
'
'<link>NodeJS Documentation|http://docs.nwjs.io/en/latest/References/Window/#winenterfullscreen</link>
Sub EnterFullscreen()
	currentWindow.RunMethod("enterFullscreen", Null)
End Sub

'
'Leave fullscreen
'
'<link>NodeJS Documentation|http://docs.nwjs.io/en/latest/References/Window/#winleavefullscreen</link>
Sub LeaveFullscreen()
	currentWindow.RunMethod("leaveFullscreen", Null)
End Sub

'
'Toggle fullscreen
'
'<link>NodeJS Documentation|http://docs.nwjs.io/en/latest/References/Window/#wintogglefullscreen</link>
Sub ToggleFullscreen()
	currentWindow.RunMethod("toggleFullscreen", Null)
End Sub

'
'Enter kioskmode
'
'<link>NodeJS Documentation|http://docs.nwjs.io/en/latest/References/Window/#winenterkioskmode</link>
Sub EnterKioskMode()
	currentWindow.RunMethod("enterKioskMode", Null)
End Sub

'
'Leave kioskmode
'
'<link>NodeJS Documentation|http://docs.nwjs.io/en/latest/References/Window/#winleavekioskmode</link>
Sub LeaveKioskMode()
	currentWindow.RunMethod("leaveKioskMode", Null)
End Sub

'
'Toggle kioskmode
'
'<link>NodeJS Documentation|http://docs.nwjs.io/en/latest/References/Window/#wintogglekioskmode</link>
Sub ToggleKioskMode()
	currentWindow.RunMethod("toggleKioskMode", Null)
End Sub

'
'Enumerate the printers in the system. The callback function will receive an array of JSON objects for the printer information. The device name of the JSON object can be used as parameter in 
'
'<link>NodeJS Documentation|http://docs.nwjs.io/en/latest/References/Window/#wingetprinterscallback</link>
Sub GetPrinters(Callback As Object)
	currentWindow.RunMethod("getPrinters", Callback)
End Sub

'
'Print the web contents in the window with or without the need for user’s interaction
'
'<link>NodeJS Documentation|http://docs.nwjs.io/en/latest/References/Window/#wingetprinterscallback</link>
Sub Print(Options As Map)
	currentWindow.RunMethod("print", Options)
End Sub

'
'Set windows maximum size.
'
'<link>NodeJS Documentation|http://docs.nwjs.io/en/latest/References/Window/#winsetmaximumsizewidth-height</link>
Sub SetMaximumSize(Width As Int, Height As Int)
	currentWindow.RunMethod("setMaximumSize", Array(Width, Height))
End Sub

'
'Set windows minimum size.
'
'<link>NodeJS Documentation|http://docs.nwjs.io/en/latest/References/Window/#winsetminimumsizewidth-height</link>
Sub SetMinimumSize(Width As Int, Height As Int)
	currentWindow.RunMethod("setMinimumSize", Array(Width, Height))
End Sub

'
'Set whether window is resizable.
'
'<link>NodeJS Documentation|http://docs.nwjs.io/en/latest/References/Window/#winsetresizableresizable</link>
Sub SetResizable(Resizable As Boolean)
	currentWindow.RunMethod("setResizable", Resizable)
End Sub

'
'Sets the widget to be on top of all other windows in the window system.
'
'<link>NodeJS Documentation|http://docs.nwjs.io/en/latest/References/Window/#winsetalwaysontoptop</link>
Sub SetAlwaysOnTop(AlwaysOnTop As Boolean)
	currentWindow.RunMethod("setAlwaysOnTop", AlwaysOnTop)
End Sub

'
'Open the devtools to inspect the window.
'
'<link>NodeJS Documentation|http://docs.nwjs.io/en/latest/References/Window/#winshowdevtoolsiframe-callback</link>
Sub ShowDevTools()
	currentWindow.RunMethod("showDevTools", Null)
End Sub

'
'Close the devtools window.
'
'<link>NodeJS Documentation|http://docs.nwjs.io/en/latest/References/Window/#winclosedevtools</link>
Sub CloseDevTools()
	currentWindow.RunMethod("closeDevTools", Null)
End Sub